platform_do_flash() {
    local tar_file=$1
    local board=$2
    local kernel=$3
    local rootfs=$4

    mkdir -p /rootfs
    mount /dev/$rootfs /rootfs

    cd /rootfs                            
    rm -rf `ls |grep -v "etc" |grep -v "crashlog" |grep -v "arm"|grep -v "crash"` 

    mkdir -p /rootfs/upgradefs
    tar xzf $tar_file -C /rootfs/upgradefs
    rm -rf /rootfs/upgradefs/crashlog    
    rm -rf /rootfs/upgradefs/arm
    rm -rf /rootfs/upgradefs/crash

    mv /rootfs/etc/cpeagent/* /rootfs/upgradefs/etc/cpeagent/
    mv /rootfs/etc/cpeagent/.[^.]* /rootfs/upgradefs/etc/cpeagent/
    rm -rf /rootfs/etc 
    mv /rootfs/upgradefs/* /rootfs        
    sync                                  
    umount /rootfs              
} 

platform_do_upgrade_espressobin() {
    local tar_file="$1"
    local board=globalscale,espressobin
    local kernel=sda1
    local rootfs=mmcblk0p1

    platform_do_flash $tar_file $board $kernel $rootfs
}

platform_copy_config_espressobin() {
  return 0
}
