<?php
	error_reporting(E_ALL ^ E_DEPRECATED);
	function decrypt($str) {
		$str = base64url_decode($str);
		$iv = mcrypt_create_iv(mcrypt_get_iv_size(MCRYPT_RIJNDAEL_128, MCRYPT_MODE_ECB), MCRYPT_RAND);
		$encrypt_str = mcrypt_decrypt(MCRYPT_RIJNDAEL_128, "appexnetworks123", $str, MCRYPT_MODE_ECB,$iv);
		$encrypt_str = stripPKSC5Padding($encrypt_str);
		return $encrypt_str;
	}

	function stripPKSC5Padding($source) {
		$char = substr($source, -1);
		$num = ord($char);
		$source = substr($source, 0, -$num);
		return $source;
	}
	
	function base64url_decode($data) {
		return base64_decode(str_pad(strtr($data, '-_', '+/'), strlen($data) % 4, '=', STR_PAD_RIGHT));
	}
	$error = "";
	$token = $_SERVER["QUERY_STRING"];
	if (empty($token)) {
		$error = "001 ";
	}
	
	// 	$key = "appexnetworks123";
	if (empty($error)) {
		$decrypt = decrypt($token);
		$array = json_decode($decrypt);
		if (empty($array)) {
			$error .= "002 ";
		}
	}
	
	//print_r($array);	
	
	//wans config
	if (empty($error)) {
		$json = json_encode($array->{'wans'}, JSON_PRETTY_PRINT);
		if (!empty($json)) {
			if (!file_exists("/etc/cpeagent/wans.conf")) {
				$error .= "501 ";
			}
		}
	}
	if (empty($error)) {
		$json = $json."\n";
		$code = file_put_contents('/etc/cpeagent/wans.conf', $json);
		if (!$code) {
			$error .= "502 ";
		}
	}
	
	//interface config
	if (empty($error)) {
		$json = json_encode($array->{'infAndDhcp'}, JSON_PRETTY_PRINT);		
		if (!empty($json) && $json!='null') {			
			if (!file_exists("/etc/cpeagent/interfaces.conf")) {
				$error .= "701 ";
			}
		}else {
			$error .= "703 ";
		}
	}
	if (empty($error)) {		
		$json = $json."\n";		
		$code = file_put_contents('/etc/cpeagent/interfaces.conf', $json);
		if (!$code) {
			$error .= "702 ";
		}
	}
	
    //ha config
	if (empty($error)) {
		if (!empty($array->{'haConfig'})) {
			$json = json_encode($array->{'haConfig'}, JSON_PRETTY_PRINT);		
			if (!empty($json) && $json!='null') {			
				if (!file_exists("/etc/cpeagent/ha.conf")) {
					$error .= "801 ";
				} else {
					$json = $json."\n";		
					$code = file_put_contents('/etc/cpeagent/ha.conf', $json);
					if (!$code) {
						$error .= "802 ";
					}
				}
			}
		}
	}
	//vpn config
	if (empty($error)) {
		if (!empty($array->{'vpnConf'})) {
			$json = json_encode($array->{'vpnConf'}, JSON_PRETTY_PRINT);		
			if (!empty($json) && $json!='null') {			
				if (!file_exists("/etc/cpeagent/vpns.conf")) {
					$error .= "901 ";
				} else {
					$json = $json."\n";		
					$code = file_put_contents('/etc/cpeagent/vpns.conf', $json);
					if (!$code) {
						$error .= "902 ";
					}
				}
			}
		}
	}	
	//cpeagent config
	// print_r($array);
	$s = "";
	if (empty($error)) {
		if (!empty($array->{'orchServer'})  && !empty($array->{'orchPort'})) {
			$str = "commaddr=".$array->{'orchServer'}.":".$array->{'orchPort'};
			$s .= $str."\n";
		} else {
			$error .= "100 ";
		}
	
		if (isset($array->{'orchId'})) {
			$str = "orchid=".$array->{'orchId'};
			$s .= $str."\n";
		} else {
			$error .= "101 ";
		}
		if (isset($array->{'cpeId'})) {
			$str = "cpeid=".$array->{'cpeId'};
			$s .= $str."\n";
		} else {
			$error .= "102 ";
		}
		if (!empty($array->{'cusId'})) {
			$str = "customerid=".$array->{'cusId'};
			$s .= $str."\n";
		} else {
			$error .= "103 ";
		}
		 if (!empty($array->{'sslServerPort'})) {
			$str = "sslport=".$array->{'sslServerPort'};
			$s .= $str."\n";
		} else {
			$error .= "105 ";
		}
		
		if (isset($array->{'haEnable'})) {
			$str = "ha=".$array->{'haEnable'};
			$s .= $str."\n";
		}

        if (!empty($array->{'commServers'})) {
            $commArray = $array->{'commServers'};
            if (count($commArray) != 0) {
                foreach($commArray as $c) {
                    $str = "bakcommaddr=".$c;
                    $s .= $str."\n";                    
                }
            }
        }
	if (isset($array->{'maxLttNum'})) {
		$str = "maxlttnum=".$array->{'maxLttNum'};
		$s .= $str."\n";
	}	
	if (isset($array->{'flowHashBits'})) {
		$str = "flowhashbits=".$array->{'flowHashBits'};
		$s .= $str."\n";
	}	
	if (isset($array->{'pmtuTimeoutMs'})) {
		$str = "pmtutimeoutms=".$array->{'pmtuTimeoutMs'};
		$s .= $str."\n";
	}	
        $str = "ztp=1\n";
        $s .= $str;
	}	
	//print_r($s);	

	if (empty($error)) {
		if (strpos($s, "commaddr") === false 
				|| strpos($s, "orchid") === false 
				|| strpos($s, "cpeid") === false 
				|| strpos($s, "customerid") === false 
				|| strpos($s, "ztp") === false 
				|| strpos($s, "sslport") === false) {
			$error .= "201 ";
		}
	}
	if (empty($error)) {
		if (!file_exists("/etc/cpeagent/cpeagent.conf")) {
			$error .= "503 ";
		}
	}
	if (empty($error)) {
		$code = file_put_contents("/etc/cpeagent/cpeagent.conf", $s);
		if (!$code) {
			$error .= "603 ";
		}
	}
    if (empty($error)) {
        if (file_exists("/etc/cpeagent/dhcp.conf")) {
            $cmd = "echo >/etc/cpeagent/dhcp.conf";
            system($cmd);
        }
        if (file_exists("/etc/cpeagent/dhcp.conf.bak")) {
            $cmd = "echo >/etc/cpeagent/dhcp.conf.bak";
            system($cmd);
        }
    }
	?>

<!DOCTYPE html>
<html>
<head>
	<meta charset="UTF-8">
	<meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1">
	<meta name="viewport" content="width=device-width, initial-scale=1">
	<title>Site Activation</title>
	<meta name="keywords" content="">
	<meta name="description" content="">
	<link rel="shortcut icon" href="favicon.ico" />
	<style type="text/css">
		body { 
			margin: 0; 
			font-family: "FzltHeis", "Helvetica Neue", Helvetica, "PingFang SC", "Hiragino Sans GB", "Microsoft YaHei", Arial, sans-serif;
		}
		section {
			position: relative;
			height: 100vh;
			min-height:100vh;
		}
		.information {
			width: 90%;
			position: absolute;
			top: 50%;
			left: 50%;
			transform: translate(-50%, -50%);
			font-size: large;
		}
		@media (min-width: 768px) {
			.information {
				width: 50%;
			}
		}
	</style>
</head>
<body>

<section>
    <div class="information">
		<?php if (empty($error)) { ?>
			<p>Congratulations! CloudWAN CPE at your site has been activated successfully!<p>
		<?php } else {?>
			<p>We are sorry! The activation of CloudWAN CPE at your site is failed. Please contact the administrator. Error code：<?php echo $error?>.</p>
		<?php }?>
    </div>
</section>

<script src="script/canvas.js"></script>

</body>
</html>
