#!/bin/sh
msg="{ \"DynIntfInfo\": { \"iptype\": \"$1\", \"ifname\": \"$2\", \"gateway\": \"$3\", \"ip\": \"$4\", \"mask\": \"$5\", \"proto\": \"$6\", \"dns\": [ \"$7\", \"$8\" ] } }"
len=$(echo $msg | wc -L)
echo "`date \"+%Y-%m-%d %H:%M:%S\"` $1 $2 $3 $4 $5 $6 $7 $8" >> /var/log/cpeagent.log
pid=$(ps | grep "cpeagent start" | grep -v grep | awk '{print $1}')
if [ ! -d "/var/run/netns" ]; then
    mkdir /var/run/netns
fi
ln -s /proc/$pid/ns/net /var/run/netns/nscpeagent
ip netns exec nscpeagent /bin/cpeagent dynamicinterface "$msg"